#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file RTC_E1_GUI.py
 @brief E1操作用GUI
 @date $Date$


"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist
import E1_GUI_Controlller
button_=0
analog_=[]
analog_=11*[0]
BUTTON_GUI=[]
BUTTON_GUI=45*[0]
ANALOG_GUI=[]
ANALOG_GUI=10*[0]
BUTTON_in=[]
BUTTON_in=45*[0]
ANALOG_in=[]
ANALOG_in=10*[0]
E1COMMAND_=[]
E1COMMAND_=50*[0]
cnt = 0
cnt_Lock = 0
R2_FLG =0
L2_FLG =0
Check_in = 0



# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
rtc_e1_gui_spec = ["implementation_id", "RTC_E1_GUI", 
		 "type_name",         "RTC_E1_GUI", 
		 "description",       "E1操作用GUI", 
		 "version",           "1.0.0", 
		 "vendor",            "AIZUK", 
		 "category",          "GUI", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class RTC_E1_GUI
# @brief E1操作用GUI
# 
# 
class RTC_E1_GUI(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_Analog = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		"""
		"""
		self._AnalogOut = OpenRTM_aist.OutPort("Analog", self._d_Analog)
		self._d_Button = RTC.TimedULong(RTC.Time(0,0),0)
		"""
		"""
		self._ButtonOut = OpenRTM_aist.OutPort("Button", self._d_Button)
		self._d_Controller_Type = RTC.TimedString(RTC.Time(0,0),0)
		"""
		"""
		self._Controller_TypeOut = OpenRTM_aist.OutPort("Controller_Type", self._d_Controller_Type)


		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>
		#円流用こマンド
		E1COMMAND_[0]="第一関節内回転"
		E1COMMAND_[1]="第一関節内回転"
		E1COMMAND_[2]="第一関節内回転"
		E1COMMAND_[3]="第一関節内回転"
		E1COMMAND_[4]="第一関節内回転"
		cnt =0
		self._d_Analog.data=[]
		self._d_Analog.data=11*[0]
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		global R2_FLG
		global cnt_Lock
		global Check_in
		cnt_Lock =0
		Check_in =0
		# Bind variables and configuration variable
		
		# Set InPort buffers
		
		# Set OutPort buffers
		self.addOutPort("Controller_Type",self._Controller_TypeOut)
		self.addOutPort("Button",self._ButtonOut)
		self.addOutPort("Analog",self._AnalogOut)
			
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		R2_FLG =0
		return RTC.RTC_OK
	
		##
		# 
		# The finalize action (on ALIVE->END transition)
		# formaer rtc_exiting_entry()
		# 
		# @return RTC::ReturnCode_t
	
		# 
	def onFinalize(self):
	
		return RTC.RTC_OK
	
		##
		#
		# The startup action when ExecutionContext startup
		# former rtc_starting_entry()
		# 
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onStartup(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The shutdown action when ExecutionContext stop
		# former rtc_stopping_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onShutdown(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The deactivated action (Active state exit action)
		# former rtc_active_exit()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
		#print "we"
		global cnt
		global button_
		global R2_FLG
		global L2_FLG 
		global BUTTON_in
		global cnt_Lock
		global Check_in
		
		
		for i in range(11):
			analog_[i]=0
		analog_[6]=-1
		analog_[7]=-1
#				print i,BUTTON_in[i]
#			print "-----------------"
		for i in range(45):
			if(BUTTON_in[i]==1):
				print i,BUTTON_in[i]
#			print "-----------------"
#		for i in range(2):
#				print ANALOG_in[0],ANALOG_in[1]
		analog_[2]=ANALOG_in[1]
		analog_[3]=ANALOG_in[0]
		print "TEX" , Check_in
		button_=0x00	
		#cnt_Lock=0
			
		if Check_in=='0':
			print "44!"
###################################################################################
#		左腕左行
###################################################################################
			if(BUTTON_in[0]):
				#左腕第１関節内回転　 →+R_Stick↑
				button_=0x00
				analog_[0]=0
				analog_[1]=1
				analog_[4]=-1
				print "1!", button_
		
			if(BUTTON_in[1]):
				#左腕第２関節内回転 　↓+R_Stick↑
				button_=0x00
				analog_[0]=1
				analog_[1]=0
				analog_[4]=-1
				print "2!", button_
			if(BUTTON_in[2]):
				#左腕第3関節内回転 　←+R_Stick↑
				button_=0x00
				analog_[0]=-1
				analog_[1]=0
				analog_[4]=-1
				print "3!", button_
			if(BUTTON_in[3]):
				#左腕第4関節内回転  ↑+R_Stick↑
				button_=0x00
				analog_[0]=0
				analog_[1]=-1
				analog_[4]=-1
				print "4!", button_
			if(BUTTON_in[4]):
				#左腕第5関節内回転  L1+R_Stick↑
				button_=0x10
				analog_[0]=0
				analog_[1]=0
				analog_[4]=-1
				print "5!", button_
			if(BUTTON_in[5]):
				#左腕第6関節内回転  L2+R_Stick↑
				button_=0x40
				analog_[0]=0
				analog_[1]=0
				analog_[4]=-1
				print "6!", button_
			if(BUTTON_in[6]):
				#左腕第7関節内回転  R3+R_Stick↑
				button_=0x800
				analog_[0]=0
				analog_[1]=0
				analog_[4]=-1
				print "7!", button_
	###################################################################################
	#		左腕右行
	###################################################################################		
			if(BUTTON_in[7]):
				#左腕第１関節内回転　 →+R_Stick↓
				button_=0x00
				analog_[0]=0
				analog_[1]=1
				analog_[4]=1
				print "1!", button_
		
			if(BUTTON_in[8]):
				#左腕第２関節内回転 　↓+R_Stick↓
				button_=0x00
				analog_[0]=1
				analog_[1]=0
				analog_[4]=1
				print "2!", button_
			if(BUTTON_in[9]):
				#左腕第3関節内回転 　←+R_Stick↓
				button_=0x00
				analog_[0]=0
				analog_[1]=-1
				analog_[4]=1
				print "3!", button_
			if(BUTTON_in[10]):
				#左腕第4関節内回転  ↑+R_Stick↓
				button_=0x00
				analog_[0]=-1
				analog_[1]=0
				analog_[4]=1
				print "4!", button_
			if(BUTTON_in[11]):
				#左腕第5関節内回転  L1+R_Stick↓
				button_=0x10
				analog_[0]=0
				analog_[1]=0
				analog_[4]=1
				print "5!", button_
			if(BUTTON_in[12]):
				#左腕第6関節内回転  L2+R_Stick↓
				button_=0x40
				analog_[0]=0
				analog_[1]=0
				analog_[4]=1
				print "6!", button_
			if(BUTTON_in[13]):
				#左腕第7関節内回転  R3+R_Stick↓
				button_=0x800
				analog_[0]=0
				analog_[1]=0
				analog_[4]=1
				print "7!", button_
	###################################################################################
	#		機能
	###################################################################################		
			if(BUTTON_in[14]):
				#頭照明  R2+↑
				button_=0x80
				analog_[0]=-1
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 1;


				print "7!", button_
			
			if BUTTON_in[14] == 0 :
				if R2_FLG == 1:
					cnt_Lock=1;
					R2_FLG = 0
				
			if(BUTTON_in[15]):
				#左側面  R2+□
				button_=0x81
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 2
				print "7!", button_
			
			if BUTTON_in[15] ==0 :
				if R2_FLG == 2:
					cnt_Lock=1;
					R2_FLG = 0

			if(BUTTON_in[16]):
				#右側面  R2+○
				button_=0x84
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 3
				print "7!", button_

			if BUTTON_in[16] ==0 :
				if R2_FLG == 3:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[17]):
				#正面  R2+△
				button_=0x88
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 4
				print "7!", button_
		
			if BUTTON_in[17] ==0 :
				if R2_FLG == 4:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[18]):
				#左腕  R2+←
				button_=0x80
				analog_[0]=0
				analog_[1]=-1
				analog_[4]=0
				R2_FLG = 5
				print "7!", button_

			if BUTTON_in[18] ==0 :
				if R2_FLG == 5:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[19]):
				#右腕  R2+→
				button_=0x80
				analog_[0]=0
				analog_[1]=1
				analog_[4]=0
				R2_FLG =6
				print "7!", button_

			if BUTTON_in[19] ==0 :
				if R2_FLG == 6:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[20]):
				#後ろ照明  R2+✕
				button_=0x82
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 7
				print "7!", button_

			if BUTTON_in[20] ==0 :
				if R2_FLG == 7:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[21]):
				#左指示器  L2+L1
				button_=0x50
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				L2_FLG = 1
				print "7!", button_
		
			if BUTTON_in[21] ==0 :
				if L2_FLG == 1:
					cnt_Lock=2;
					L2_FLG = 0
			

			if(BUTTON_in[22]):
				#右指示器  L2+R1
				button_=0x60
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				L2_FLG = 2
				print "7!", button_

			if BUTTON_in[22] ==0 :
				if L2_FLG == 2:
					cnt_Lock=2;
					L2_FLG = 0
			
			if(BUTTON_in[23]):
				#ホーン  R2+↓
				button_=0x80
				analog_[0]=1
				analog_[1]=0
				analog_[4]=0
				R2_FLG = 8
				print "7!", button_

			if BUTTON_in[23] ==0 :
				if R2_FLG == 8:
					cnt_Lock=1;
					R2_FLG = 0
			
			if(BUTTON_in[24]):
				#ハザード  L2+○
				button_=0x44
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				L2_FLG = 3
				print "7!", button_

			if BUTTON_in[24] ==0 :
				if L2_FLG == 3:
					cnt_Lock=2;
					L2_FLG = 0
			
			
			if(BUTTON_in[41]):
				#アクセルアップ L2+△
				button_=0x48
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				L2_FLG = 4
				print "7!", button_

			if BUTTON_in[41] ==0 :
				if L2_FLG == 4:
					cnt_Lock=2;
					L2_FLG = 0
			
			
			if(BUTTON_in[42]):
				#アクセルダウン L2+✕
				button_=0x42
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				L2_FLG = 5
				print "7!", button_

			if BUTTON_in[42] ==0 :
				if L2_FLG == 5:
					cnt_Lock=2;
					L2_FLG = 0
			
			if(BUTTON_in[25]):
				#ブレード 上げ Share
				button_=0x100
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				print "7!", button_

			if(BUTTON_in[26]):
				#ブレード下げ  Option
				button_=0x200
				analog_[0]=0
				analog_[1]=0
				analog_[4]=0
				print "7!", button_
	###################################################################################
	#		右腕左行
	###################################################################################	

			if(BUTTON_in[27]):
				#右腕第１関節内回転　 □+L_Stick↑
				button_=0x01
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[28]):
				#右腕第２関節内回転　 ✕+L_Stick↑
				button_=0x02
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[29]):
				#右腕第3関節内回転　 ○+L_Stick↑
				button_=0x04
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[30]):
				#右腕第4関節内回転　 △+L_Stick↑
				button_=0x08
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[31]):
				#右腕第5関節内回転　 R1+L_Stick↑
				button_=0x20
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			
			if(BUTTON_in[32]):
				#右腕第6関節内回転　 R2+L_Stick↑
				button_=0x80
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[33]):
				#右腕第7関節内回転　 L3+L_Stick↑
				button_=0x400
				analog_[0]=0
				analog_[1]=0
				analog_[2]=-1
				analog_[4]=0
				print "1!", button_
	###################################################################################
	#		右腕右行
	###################################################################################	
			if(BUTTON_in[34]):
				#右腕第１関節内回転　 □+L_Stick↑
				button_=0x01
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[35]):
				#右腕第２関節内回転　 ✕+L_Stick↑
				button_=0x02
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[36]):
				#右腕第3関節内回転　 ○+L_Stick↑
				button_=0x04
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[37]):
				#右腕第4関節内回転　 △+L_Stick↑
				button_=0x08
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[38]):
				#右腕第5関節内回転　 R1+L_Stick↑
				button_=0x20
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			
			if(BUTTON_in[39]):
				#右腕第6関節内回転　 R2+L_Stick↑
				button_=0x80
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			if(BUTTON_in[40]):
				#右腕第7関節内回転　 L3+L_Stick↑
				button_=0x400
				analog_[0]=0
				analog_[1]=0
				analog_[2]=1
				analog_[4]=0
				print "1!", button_
			
		else:
			print "40!"
			button_= 0
			analog_[2]=0
			analog_[3]=0
			analog_[4]=0
			analog_[5]=ANALOG_in[0]
			
		print button_	
		
		if cnt_Lock==1 :
			button_=0x80
		        analog_[0]=0
			analog_[1]=0
			analog_[2]=0
			analog_[3]=0
			analog_[4]=0
			analog_[5]=0
			analog_[6]=0
			analog_[7]=1
			cnt= cnt + 1
			
		if cnt_Lock==2 :
			button_=0x40
		        analog_[0]=0
			analog_[1]=0
			analog_[2]=0
			analog_[3]=0
			analog_[4]=0
			analog_[5]=0
			analog_[6]=1
			analog_[7]=0
			cnt= cnt + 1
			
		
		if cnt >2 and cnt_Lock>0 :
			cnt_Lock =0
			
		if cnt_Lock == 0:
			cnt=0
		print "ENR", cnt_Lock, R2_FLG
		self._d_Button.data = button_
		self._ButtonOut.write()
		self._d_Analog.data[0] = analog_[0]
		self._d_Analog.data[1] = analog_[1]
		self._d_Analog.data[2] = analog_[2]
		self._d_Analog.data[3] = analog_[3]
		self._d_Analog.data[4] = analog_[4]
		self._d_Analog.data[5] = analog_[5]
		self._d_Analog.data[6] = analog_[6]
		self._d_Analog.data[7] = analog_[7]
		self._AnalogOut.write()
		self._d_Controller_Type.data = "E1_GUI"
		self._Controller_TypeOut.write()
		
		return RTC.RTC_OK
	
		##
		#
		# The aborting action when main logic error occurred.
		# former rtc_aborting_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onAborting(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The error action in ERROR state
		# former rtc_error_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onError(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The reset action that is invoked resetting
		# This is same but different the former rtc_init_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onReset(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The state update action that is invoked after onExecute() action
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#

		#
	def onStateUpdate(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The action that is invoked when execution context's rate is changed
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onRateChanged(self, ec_id):
	
		return RTC.RTC_OK
		
	def get_data(self,BUTTON_GUI,ANALOG_GUI,ChecK):
		global Check_in  
		for i in range(45):
			BUTTON_in[i] = BUTTON_GUI[i]
			
		for i in range(2):
			ANALOG_in[i] = ANALOG_GUI[i] 
			
		Check_in=ChecK
		print ChecK ,Check_in



def RTC_E1_GUIInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=rtc_e1_gui_spec)
    manager.registerFactory(profile,
                            RTC_E1_GUI,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    RTC_E1_GUIInit(manager)

    # Create a component
    comp = manager.createComponent("RTC_E1_GUI")

def main():
#GUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUI#

	E1_GUI = E1_GUI_Controlller.E1_GUI_Cont()
	E1_GUI.master.title("E1 GUI")#window名
	
#GUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUI#
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	#mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	RTC_E1_GUIInit(mgr)
    	comp = mgr.createComponent("RTC_E1_GUI")
 	E1_GUI.set_on_update(comp.get_data)
	mgr.runManager(True)
	E1_GUI.mainloop()

if __name__ == "__main__":
	main()

